import { CharacterRigR6 } from "@rbxts/character-promise"
import Log, { Logger } from "@rbxts/log"
import { Players } from "@rbxts/services"
import { start } from "ReplicatedStorage/ecs"
import { ClientState } from "ReplicatedStorage/ecs/state"
import { Host } from "ReplicatedStorage/hosts"
import { setEnvironment } from "ReplicatedStorage/idAttribute"
import showGUI from "./showGUI"

const HOST = Host.Client

const clientLogger = Logger.configure()
    .WriteTo(Log.RobloxOutput())
    .Create()

const clientState = new ClientState(
    Players.LocalPlayer,
    (Players.LocalPlayer.Character || Players.LocalPlayer.CharacterAdded.Wait()[0]) as CharacterRigR6,
    false,
    false,
    Players.LocalPlayer.WaitForChild("Backpack") as Backpack,

    clientLogger
)

const worldAndClientState = start(HOST, clientState)
showGUI(worldAndClientState[0], clientState)
setEnvironment(HOST)